package com.epoll;

import Interface.IUdpReceiver;
import utils.SingleThread;

public class EpollClientImpl {
	private SingleThread singledataThread = SingleThread.getInstance();
	public EpollClientImpl(int port ,IUdpReceiver udpreceiver) {
		/**
		 * 构建IUdpReceiver后 再用单线程池原因是,jni回调Java是异步的 而且每次回调都会构造一个新线程
		 * 为了实现数据排队处理 所以用单线程回调
		 */
		init(port,new IUdpReceiver() {
			@Override
			public void receiveSinglePckString(byte[] data, short PackNum, byte Type, short Count) {
				singledataThread.execute(new Runnable() {
					
					@Override
					public void run() {
						// TODO Auto-generated method stub
						udpreceiver.receiveSinglePckString(data, PackNum, Type, Count);
					}
				});
			}
		});
	}
	/**
	 * 
	 * @param port 网络接口
	 * @param udpreceiver 回调
	 */
	private native void init(int port ,IUdpReceiver udpreceiver);
	/**
	 * @param sip 服务端ip地址 port 对端网络端口
	 * @return 1连接服务端 0没有连接上
	 */
	public native int connect(String sip ,int port);
	/**
	 * 
	 * @param type 发送数据类型
	 * @param data
	 * @return
	 */
	public native int sendData(byte type ,byte[] data);
	/**
	 * 
	 * @param timespace 心跳包间隔时间
	 * @return
	 */
	public native int startHeart(int timespace);
	/**
	 * 在这个对象不使用时候
	 * 回收内存
	 */
	public native void release();
}
