package com.epoll;

import Interface.IUdpReceiver;
import utils.SingleThread;

public class EpollServerImpl {
	private SingleThread singledataThread = SingleThread.getInstance();
	public EpollServerImpl(int port ,IUdpReceiver udpreceiver) {
		//原理请看EpollClientImpl.java 
		init(port,new IUdpReceiver() {
			@Override
			public void receiveSinglePckString(byte[] data, short PackNum, byte Type, short Count) {
				singledataThread.execute(new Runnable() {
					
					@Override
					public void run() {
						// TODO Auto-generated method stub
						udpreceiver.receiveSinglePckString(data, PackNum, Type, Count);
					}
				});
			}
		});
	}
	/**
	 * 
	 * @param port 网络接口
	 * @param udpreceiver 回调
	 */
	private native void init(int port ,IUdpReceiver udpreceiver);
	/**
	 * 
	 * @param timeout 等待超时小于1就阻塞
	 * @return 1 连接上客户端 0客户端关闭
	 */
	public native int accept(int timeout);
	/**
	 * 
	 * @param type 发送数据类型
	 * @param data
	 * @return
	 */
	public native int sendData(byte type ,byte[] data);
	/**
	 * 
	 * @param timespace 心跳包间隔时间
	 * @return
	 */
	public native int startHeart(int timespace);
	/**
	 * 在这个对象不使用时候
	 * 回收内存
	 */
	public native void release();
}
