package utils;

import java.util.Vector;

public class SingleThread {
	private Vector<Runnable> task = new Vector();
	private Thread singleThread = null;
	private boolean kill = false;
	
	private SingleThread() {
		singleThread = new Thread() {
			public void run() {
				while(!kill) {
					if(task.size() == 0) {
						synchronized (singleThread) {
							if(task.size() == 0) {
								try {
									this.wait();
								} catch (InterruptedException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
							}
						}
					}
					
					Runnable obj = task.get(0);
					task.remove(obj);
					obj.run();
				}
				
			}
		};
		singleThread.start();
		
	}
	
	
	public static SingleThread getInstance() {
		return new SingleThread();
	}
	
	public void execute(Runnable runnable) {
		synchronized (singleThread) {
			task.add(runnable);
			singleThread.notify();
		}
	}
	public void shutdown() {
		kill = true;
	}

}
